#include <rabbit.h>
#include <stdio.h>

// these are in cstart
extern unsigned long _xmemSize,_xmemEnd,_xmemHeap;

char far * bb_xalloc(unsigned long bb_size)
{
    if ((_xmemEnd-0x80000l)<bb_size) // bbram starts at 0x80000
       return (char far *)NULL;
    if ((_xmemEnd-_xmemHeap)<bb_size) // no free xmem at all!
       return (char far *)NULL;
	_xmemSize-=bb_size; // tell xalloc() there is bb_size bytes used
	_xmemEnd-=bb_size;
    return (char far *)_xmemEnd; // where our BB_BSS data resides
}

unsigned long bb_xavail(void)
{
    if (_xmemEnd<0x80000l) // bbram starts at 0x80000
       return 0l;
    return (_xmemEnd-0x80000l);
}

int bb_xrelease(char far * base,unsigned long size)
{
	if (_xmemEnd!=(unsigned long)base)
		return -1;
	_xmemEnd+=size;
	return 0;
}

