#include <rabbit.h>
#include <stdio.h>

static void dummy_asm(void)
{
#asm
	.seg push
	.defseg BB_BSS
	.seg pop
#endasm
}
#pragma offset_labels on
#pragma warn -760
void map_bb_ram(char far * bb_addr)
{
#asm
    ld   b,sgst BB_BSS>>12
  ioi ld a,(SEGSIZE)
    or   b  ; add our BB_SEG start address
  ioi ld (SEGSIZE),a
    ld   hl,(ix+.bb_addr) ; get lower 16 bits
    ld   a,(ix+.bb_addr+2) ; get uypper 4 bits
    ld   de,0x0fff
    add  hl,de  ; round up
    jr   nc,..same_64k
    inc  a
..same_64k:
    add  hl,hl ; shift upper 4 buts of HL into
    rla
    add  hl,hl
    rla
    add  hl,hl
    rla
    add  hl,hl
    rla
 ; A now has upper 8-bits of physical address
    sub  sgst BB_BSS>>12 ; subtract locgical address 4k
    ioi  ld (DATASEG),a
#endasm
}
#pragma warn 760

unsigned get_bb_size(void)
{
	unsigned bb_size;
#asm
    ld   hl,sgsz BB_BSS
#endasm
    bb_size=_HL; //asm left HL with size of BB_BSS
    bb_size+=0x0fff; // round up 4k
    bb_size&=0xf000; // # of 4k pages
	return bb_size;
}
